//Conv_filter_c.x input.dat@ size_n nhist
#include <float.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include <string.h>

#include "seplib.h"
#include "alloc.h"

#include "Conv_filter_c.h"

#define BUF 1024

main(int argc,char *argv[])
{

    char sz_filter[BUF];
    char sz_filter_2[BUF];

    float **xx, **yy, **bb;
    int nx,nb,nx2,nb2,i,j,ny;
    float ox,dx,dx2,ox2;
    double **dxx, **dyy, **dbb;
    int if_filter_2=1;
    int nc,nc2;

    if (argc<2) 
    {
       fprintf(stderr,"Conv_filter < input.H > output.H filter=[filter file name]\n");
       exit(0);
    }
    initpar(argc,argv);
    if(0==hetch("n1","i",&nx)) seperr("\tTrouble obtaining n1 from the dataset \n");
    if(0==hetch("o1","f",&ox)) seperr("\tTrouble obtaining o1 from the dataset \n");
    if(0==hetch("d1","f",&dx)) seperr("\tTrouble obtaining d1 from the dataset \n");
    if(0==hetch("n2","i",&nx2)) nx2=1;
    if(0==hetch("o2","f",&ox2)) ox2=0;
    if(0==hetch("d2","f",&dx2)) dx2=1;

    if(0==getch("filter","s",sz_filter)) seperr("\tTrouble obtaining filter from the cmd line.\n");

    if(0==getch("filter2","s",sz_filter_2)) if_filter_2=0;

    auxpar("n1","i", &nb, sz_filter);
    auxpar("n2","i", &nb2, sz_filter);

    if (nb2 != nx2)
    {
        seperr("nb2!=nx2\n");
    }

    ny=nx+nb-1;

    xx=malloc2float(nx2,nx);
    bb=malloc2float(nb2,nb);
    yy=malloc2float(nx2,ny);
    assert(xx);
    assert(bb);
    assert(yy);

    dxx=malloc2double(nx2,nx);
    dbb=malloc2double(nb2,nb);
    dyy=malloc2double(nx2,ny);

    assert(dxx);
    assert(dbb);
    assert(dyy);

    if (nx*nx2*sizeof(float)!=sreed("in",xx[0],nx*nx2*sizeof(float)))
    {
        seperr("\tTrouble reading data from the dataset. lenth=%d \n",nx*nx2*sizeof(float));
    }
    if (nb*nb2*sizeof(float)!=sreed(sz_filter,bb[0],nb*nb2*sizeof(float)))
    {
        seperr("\tTrouble reading data from %s. lenth=%d \n",sz_filter,nb*nb2*sizeof(float));
    }



//     for (i=0;i<nx2;i++)
//     {
//         float_conv(0,xx[i],bb[i],yy[i],nx,nb,ny);
//     }

    for (i=0;i<nx2;i++)
      for (j=0;j<nx;j++)
      {
          dxx[i][j]=(double)(xx[i][j]);
      }

    for (i=0;i<nb2;i++)
      for (j=0;j<nb;j++)
      {
          dbb[i][j]=(double)(bb[i][j]);
      }

    for (i=0;i<nx2;i++)
    {
        double_conv(0,dxx[i],dbb[i],dyy[i],nx,nb,ny);
    }


// for second filter
    if(if_filter_2)
    {
        auxpar("n1","i", &nc, sz_filter_2);
        auxpar("n2","i", &nc2, sz_filter_2);

        if (nc2 != nx2)
        {
            seperr("nc2!=nx2\n");
        }

        free2double(dxx);
        free2double(dbb);
        free2float(bb);

        dxx=malloc2double(nx2,ny);
        dbb=malloc2double(nc2,nc);
        bb=malloc2float(nc2,nc);

        assert(dxx);
        assert(dbb);
        assert(bb);

        memmove(dxx[0], dyy[0], nx2*ny*sizeof(double));
        nx=ny;

        ny=ny+nc-1;

        free2float(yy);
        yy=malloc2float(nx2,ny);
        assert(yy);

        free2double(dyy);
        dyy=malloc2double(nx2,ny);
        assert(dyy);
        auxclose(sz_filter);

        if (nc*nc2*sizeof(float)!=sreed(sz_filter_2,bb[0],nc*nc2*sizeof(float)))
        {
            seperr("\tTrouble reading data from filter_2:%s. lenth=%d nc=%d nc2=%d \n",sz_filter_2,nc*nc2*sizeof(float),nc,nc2);
        }

        for (i=0;i<nc2;i++)
          for (j=0;j<nc;j++)
          {
              dbb[i][j]=(double)(bb[i][j]);
          }

        for (i=0;i<nx2;i++)
        {
            double_conv(0,dxx[i],dbb[i],dyy[i],nx,nc,ny);
        }
    }

    putch("n1","i",&ny);
    putch("o1","f",&ox);
    putch("d1","f",&dx);
    putch("n2","i",&nx2);
    putch("o2","f",&ox2);
    putch("d2","f",&dx2);

    for (i=0;i<nx2;i++)
      for (j=0;j<ny;j++)
      {
          yy[i][j]=(float)(dyy[i][j]);
      }

    if(ny*nx2*sizeof(float) != srite("out", yy[0] , ny*nx2*sizeof(float)))
    {
        seperr("\trouble writing data \n");
    }
    


    hclose();

    free2float(xx);
    free2float(yy);
    free2float(bb);

    free2double(dxx);
    free2double(dyy);
    free2double(dbb);

}


// void float_conv(int adj,float *xx,float *bb,float *yy, int nx, int nb, int ny)
// {
//     int x,y,b;
//     if(ny<nx+nb-1) seperr("ny<nx+nb-1");
// 
//     for (b=0;b<nb;b++)
//       for (x=0;x<nx;x++)
//       {
//           y=x+b;
//           if (adj)
//           {
//             bb[b]=bb[b]+yy[y]*xx[x];
//           }
//           else
//           {
//             yy[y]=yy[y]+bb[b]*xx[x];
//           }
//       }
// }

void double_conv(int adj,double *xx,double *bb,double *yy, int nx, int nb, int ny)
{
    int x,y,b;
    double temp;

    if(ny<nx+nb-1) seperr("ny<nx+nb-1");

    for (b=0;b<nb;b++)
      for (x=0;x<nx;x++)
      {
          y=x+b;
          if (adj)
          {
            temp=bb[b];
            bb[b]=bb[b]+yy[y]*xx[x];
//             assert(bb[b]!=temp||yy[y]==0||xx[x]==0);
          }
          else
          {
            temp=yy[y];
            yy[y]=yy[y]+bb[b]*xx[x];
//             assert(yy[y]!=temp||bb[b]==0||xx[x]==0);
//             if (!(yy[y]!=temp||bb[b]==0||xx[x]==0))
//             {
//               fprintf(stderr,"%lld %lld %lld\n",sizeof(xx[0]),sizeof(bb[0]),sizeof(yy[0]));
//               fprintf(stderr,"%d %d %d %a %a %a %a\n",y,b,x,yy[y],bb[b],xx[x],temp);
//             }
          }
      }
}

