program test_op

  use t_conv_data
  use t_conv_filter
  use op_sparse_decon_mod

  use dottest
  implicit none

  integer,parameter :: n1 = 512, n2=512

  integer,parameter :: nfilt = 128
  real, dimension(:),allocatable :: A,B, filter
  real :: dot1(2),dot2(2), eps
  integer n

  n = n1*n2
  allocate(A(n), B(n), filter(nfilt))

!!$  call random_number( filter)
!!$  call t_conv_data_init(filter,n1,n2)
!!$  write(0,*) 'Starts to run dot test, t_conv_data' 
!!$  dot1=0; dot2=0
!!$  write(0,*) '--- DOT PRODUCT TEST -------------------------------------'
!!$  call dot_test( t_conv_data_lop, n, n, dot1, dot2)
!!$  write(0,*) '-------------------------------------------------------------------'
!!$
!!$


!!$!------------------------------
!!$  call random_number( A)
!!$  call t_conv_filter_init(A,n1,n2,0)
!!$  write(0,*) 'Starts to run dot test, t_conv_filter' 
!!$  dot1=0; dot2=0
!!$  write(0,*) '--- DOT PRODUCT TEST -------------------------------------'
!!$  call dot_test( t_conv_filter_lop, nfilt, n, dot1, dot2)
!!$  write(0,*) '-------------------------------------------------------------------'
!!$!------------------------------
!!$
!!$
!!$!------------------------------
!!$  call laplac1_init(nfilt)
!!$  write(0,*) 'Starts to run dot test, laplac1d'
!!$  dot1=0; dot2=0
!!$  write(0,*) '--- DOT PRODUCT TEST -------------------------------------'
!!$  call dot_test( laplac1_lop, nfilt, nfilt, dot1, dot2)
!!$  write(0,*) '-------------------------------------------------------------------'
!!$!------------------------------


!!$Starts to run dot test, t_conv_data
!!$ --- DOT PRODUCT TEST -------------------------------------
!!$   3887395.       3887388.    
!!$   7774790.       7774777.    
!!$ -------------------------------------------------------------------
!!$ Starts to run dot test, t_conv_filter
!!$ --- DOT PRODUCT TEST -------------------------------------
!!$   3924681.       3924633.    
!!$   7849362.       7849039.    
!!$ -------------------------------------------------------------------
!!$ Starts to run dot test, laplac1d
!!$ --- DOT PRODUCT TEST -------------------------------------
!!$  -2.884873      -2.884873    
!!$  -5.769746      -5.769746    
!!$ -------------------------------------------------------------------

  !Test Op_MA------------------------------
  call random_number( filter)

  call random_number( A)
  call t_conv_filter_init(A,n1,n2,0)
  call t_conv_data_init(filter,n1,n2)
  call laplac1_init(nfilt)

  eps = 1e4
  call op_MA_init(n1,n2,nfilt,eps,nfilt)
  write(0,*) 'Starts to run dot test, op_MA'
  dot1=0; dot2=0
  write(0,*) '--- DOT PRODUCT TEST -------------------------------------'
  call dot_test( op_MA, nfilt+n1*n2, n1*n2 , dot1, dot2)
  write(0,*) '-------------------------------------------------------------------'
  !------------------------------

  write(0,*) 'Starts to run dot test, op_MA_and_Rma'
  dot1=0; dot2=0
  write(0,*) '--- DOT PRODUCT TEST -------------------------------------'
  call dot_test( op_MA_and_Rma, nfilt+n1*n2, n1*n2+nfilt, dot1, dot2)
  write(0,*) '-------------------------------------------------------------------'
  !------------------------------

  deallocate(A,B,filter)
end program test_op
