! Kirchhoff modeling and migration.
program Kapp

  use Kirchhoff
  use sep
  use util_axisIO

  implicit none
  real, allocatable, dimension (:,:) :: modl
  real, allocatable, dimension (:,:) :: data
  real, allocatable, dimension (:) :: vrms
  integer i,n1,n2,n3, adj, istart,iend,iangle
  ! <in.H Kirchhoff adj= vel=vel.H > out.H
  ! adj=0 means model. adj=1 means migrate.
  real velocity, t0,dt,dx,d3, angle

  type(myaxis)  axis1,axis2,axis3

  call sep_init()

  call hinaxis(axis1,1)
  call hinaxis(axis2,2)
  
  call houtaxis(axis1,1)
  call houtaxis(axis2,2)

  n1 = axis1%n
  n2 = axis2%n

  allocate (modl(n1,n2))
  allocate (data(n1,n2))
  allocate (vrms(n1))

  call from_param("adj",adj,0 )

  call from_param("istart",istart,5)
  call from_param("iend",iend,90)
  call from_param("iangle",iangle,10)


!!$n3=(iend-istart)/iangle + 1
!!$  if (0.ne. putch('n3','d',n3 )) then
!!$    call erexit('Trouble writing  n3 to history  ')
!!$  end if

  call hclose()
  vrms=0;data=0; modl=0
  call sreed( 'vel', vrms, n1*4)
  
  !Convert to km
  vrms = vrms / 1000
  vrms=vrms/2  !Convert to halfway

  if ( adj .eq. 0 ) then
     call sep_read(modl)
  else
     call sep_read(data)
  end if
  

  do i=1,n1
     write(0,*) 'vrms (', i, ')', vrms(i)
  enddo
  
  dt = axis1%d
  dx = axis2%d
  t0 = axis1%o
  
  angle = 75

  call kirchfast( adj, 0, vrms, angle, t0,dt,dx, n1,n2, modl, data)

  

!!$  j = 0
!!$  do i=istart,iend,iangle
!!$     j = j + 1
!!$  end do
!!$  call set_axis(axis3, j , iangle, istart)
!!$  call houtaxis(axis3)
!!$do i=istart,iend,iangle
!!$  angle=float(i)
!!$  write(0,*) i/iangle,angle
!!$  call kirchfast( adj, 0, vrms, angle, t0,dt,dx, n1,n2, modl, data)
  if ( adj .eq. 0 ) then
     write(0,*) "output the data"
     !call srite( 'out', data, n1*n2*4)
     call sep_write(data)
  else
     write(0,*) "output the model"
     call sep_write(modl)
     !call srite( 'out', modl, n1*n2*4)
  end if


!!$end do
  call sep_close()

end program Kapp

