!according to Jon's non-minphase talk
!Do regression alternatively

!1: (d*rev(b))*a - ma= ra
!	 eps*ma = rm <-- hybrid

!2: (rev(d*a))*b - mb = rb
!	 eps*mb = rm <-- hybrid


module Sparse_decon_mixed_Da_mod
!define all variables here
  use sep
  use util_axisIO

  !use solver_reg_nrm_bd_mod
  use plane_search_mod
  use mask1
  use solver_reg_nrm_bd_prec_mod
  use pef_bd_mod

  use t_conv_filter  
  use t_conv_data   
  use misc

  implicit none


  integer :: n1,n2
  type(myaxis)  axis1, axis2, axis_iter,axis_wavelet

  ! <in.H Sparse_decon filt=filter.H > out.H



  integer ::filter_len

  integer                          :: niter_nl,niter_lin, iter_nl

  real                             :: qnt_d,qnt_m
  real                             :: r_th_d, r_th_m, r_th_m_origi
  logical                          :: l_use_rthd, l_use_rthm


  integer :: zero_lag
  integer :: max_overshot_cnt

  real, dimension(:),allocatable :: tmp_ar
  integer :: psiter      !maximum iterations allowed in plan search
  integer :: qt_period   !Allow quantile change after certain iterations

  character(12)  ::str_norm_mod, str_norm_dat
  real ::eps,alpha

  integer        ::stat

  real, dimension(:), allocatable :: error
  integer :: niter0

  logical bsave,T,F
  integer i,j,k, nframe,n12

  logical :: bUseMask
  type(myaxis) :: axisT

  integer:: iRecord, iFilterLen,maxConvLength,iShift
  
  !real, allocatable, dimension(:) :: filter_specreg
  real, dimension(:),allocatable:: d,b_r_d_conv,d_a_conv_r,d_conv_a,dd,model_a,model_b
  real, dimension(:), allocatable :: a,b,ra,rb,wavelet,convRes,a_and_m
  logical, pointer, dimension(:) :: mask
  real, dimension(:), allocatable :: resda,resdb,resm 
  real :: maxV
  logical :: l_invert_b_first;

  !All the tags in params
  character(len=256) :: csz_filterA,csz_filterB,csz_qntd,csz_qntm,csz_niter_nl, &
  & csz_niter_lin,csz_psiter,csz_qt_period,csz_filt_len,&
  & csz_model_b,csz_wavelet, csz_convRes, &
  & csz_resda, csz_resdb, csz_alpha, csz_eps, csz_calc_b_first

  contains

  subroutine invert_a
  !calc d conv rb first
  
  call reverseArray(b,rb,iFilterLen,1);
  write(0,*) "rb=", rb
  call t_conv_data_init(rb,n1,n2)
  stat = t_conv_data_lop(.false.,.false.,d,b_r_d_conv)


  !Init opertor
  !write(0,*) "b_r_d_conv",b_r_d_conv
  call t_conv_filter_init(b_r_d_conv,n1,n2)
  
  call set_axis(axisT,n12,0.0,0.004,"")
  call houtaxis(axisT,1,"dump")
  call sep_write(b_r_d_conv,"dump")

   
  dd = 0
  a_and_m = 0
  a_and_m(1+zero_lag) = 1.0

  r_th_m = r_th_m_origi * eps
  resda = 0; resm=0
	

  write(0,*) "invoke the norm solver,step I"
  
  if(abs(r_th_m_origi+1.0)<1e-6) then
	  write(0,*) "call the solver_reg_nrm_bd_prec_mod with quantile"
  	  call solver_reg_nrm_bd_prec( m=a_and_m, d=dd, Fop=t_conv_filter_lop, &
             & Aop=unit_lop, Jop=mask1_lop, stepper=cgstep_ps, nAop=n1*n2, niter=niter_lin, eps=eps,&
             & alpha=alpha, norm_dat_in=str_norm_dat, norm_mod_in=str_norm_mod, &
             & qnt_dat_in=qnt_d, qnt_mod_in=qnt_m, &
             & psiter=psiter, overshot_shrink_max_cnt_in=8, qt_period_in=qt_period,&
             & m0=a_and_m, resd=resda, resm=resm)
			 else
	  write(0,*) "call the solver_reg_nrm_bd_prec_mod with r_th_m value"
  	  call solver_reg_nrm_bd_prec( m=a_and_m, d=dd, Fop=t_conv_filter_lop, &
             & Aop=unit_lop, Jop=mask1_lop, stepper=cgstep_ps, nAop=n1*n2, niter=niter_lin, eps=eps,&
             & alpha=alpha, norm_dat_in=str_norm_dat, norm_mod_in=str_norm_mod, &
             & qnt_dat_in=qnt_d, R_th_m_in=r_th_m, &
             & psiter=psiter, overshot_shrink_max_cnt_in=8, qt_period_in=qt_period,&
             & m0=a_and_m, resd=resda, resm=resm)
	endif
  !reassemble the xx and filter
  a(1:iFilterLen) = a_and_m(1:iFilterLen)
  model_a = a_and_m(iFilterLen+1:);
 

  write(0,*) "Finish the call of solver_reg_nrm_bd_prec, step1"
  write(0,*) "max model_a", maxval(abs(model_a))

  call solver_reg_nrm_bd_prec_close()

  end subroutine invert_a


!!!! Subroutine for inverting b filter  
  subroutine invert_b

  d_a_conv_r = 0
  call t_conv_data_init(a,n1,n2)
  stat = t_conv_data_lop(.false.,.false.,d,d_conv_a)
  call reverseArray(d_conv_a,d_a_conv_r,n1,n2)
  !write(0,*) "d_a_conv_r", d_a_conv_r

  !Need to shift d_a_conv_r left, otherwise the non-zeros
  !Are gathering at the right end.
  iShift=0
  maxV = maxval(abs(d_a_conv_r))
  do while (T)
    if (abs(d_a_conv_r(iShift+1)) < 1e-3 * maxV) then
	 	iShift = iShift + 1
	else
		exit
	endif
  enddo 
 
  iShift = iShift -5 !Make some safe boundary
  iShift = max(iShift,0)

  write(0,*) "Shift d_a_conv_r by", iShift

  call shiftArray(d_a_conv_r,n1,n2,iShift)
  !Init opertor
  call t_conv_filter_init(d_a_conv_r,n1,n2)
  dd = 0

  a_and_m = 0
  a_and_m(1+zero_lag) = 1.0

  r_th_m = r_th_m_origi * eps
  resdb = 0; resm=0

  write(0,*) "invoke the norm solver,step II"
  
  if(abs(r_th_m_origi+1.0)<1e-6) then
  call solver_reg_nrm_bd_prec( m=a_and_m, d=dd, Fop=t_conv_filter_lop, &
             & Aop=unit_lop, Jop=mask1_lop, stepper=cgstep_ps, nAop=n1*n2, niter=niter_lin, eps=eps,&
             & alpha=alpha, norm_dat_in=str_norm_dat, norm_mod_in=str_norm_mod, &
             & qnt_dat_in=qnt_d, qnt_mod_in=qnt_m, &
             & psiter=psiter, overshot_shrink_max_cnt_in=8, qt_period_in=qt_period,&
             & m0=a_and_m, resd=resdb, resm=resm)
			 else
	  
			write(0,*) "call the solver_reg_nrm_bd_prec_mod with r_th_m value"
  	      call solver_reg_nrm_bd_prec( m=a_and_m, d=dd, Fop=t_conv_filter_lop, &
             & Aop=unit_lop, Jop=mask1_lop, stepper=cgstep_ps, nAop=n1*n2, niter=niter_lin, eps=eps,&
             & alpha=alpha, norm_dat_in=str_norm_dat, norm_mod_in=str_norm_mod, &
             & qnt_dat_in=qnt_d, R_th_m_in=r_th_m, &
             & psiter=psiter, overshot_shrink_max_cnt_in=8, qt_period_in=qt_period,&
             & m0=a_and_m, resd=resdb, resm=resm)
	endif

  !Assemble filter and model
  b(1:iFilterLen) = a_and_m(1:iFilterLen)
  model_b = a_and_m(iFilterLen+1:);
  write(0,*) "Finish the call of solver, step2"
  write(0,*) "max model_b", maxval(abs(model_b))

  call solver_reg_nrm_bd_prec_close()
  end subroutine invert_b


end module

program Sparse_decon_mixed_Da
  use sep
  use util_axisIO

  !use solver_reg_nrm_bd_mod
  use plane_search_mod
  use mask1

  use t_conv_filter  
  use t_conv_data   
  use misc
  use Sparse_decon_mixed_Da_mod

  implicit none



  csz_filterA = "filter_a"
  csz_filterB = "filter_b"
  csz_qntd = "qnt_d"
  csz_qntm = "qnt_m"
  csz_niter_nl = "niter_nl"
  csz_niter_lin = "niter_lin"
  csz_psiter = "psiter"
  csz_qt_period = "qt_period"
  csz_filt_len = "filt_length"
  csz_model_b = "model_b"
  csz_wavelet = "wavelet"
  csz_convRes = "conv_res"
  csz_eps = "eps"
  csz_alpha = "alpha"
  csz_model_b = "model_b"
  csz_resda = "resda"
  csz_resdb = "resdb"
  csz_calc_b_first = "calc_b_first"

  T = .true. ; F = .false.
  !Params
  call sep_init()

  call from_param("UseMask",bUseMask,.false.)

  call hinaxis(axis1,1)
  call hinaxis(axis2,2)
  n1 = axis1%n; n2 = axis2%n

  call from_param (csz_niter_nl, niter_nl, 1)
  call from_param (csz_niter_lin, niter_lin, 1)   !should be a small number
  write(0,*) "niter_nl/lin=",niter_nl, niter_lin

  call from_param (csz_psiter,psiter,2); 
  write(0,*) "psiter=",psiter

  call from_param (csz_qt_period,qt_period,1000); 
  write(0,*) csz_qt_period,"=",qt_period
  
  call from_param ("max_overshot_shrink_cnt", max_overshot_cnt, 0)
  write(0,*) "max_overshot_cnt=", max_overshot_cnt

  call from_param   (csz_qntd, qnt_d, .9) 
  call from_param   (csz_qntm, qnt_m, .9) 
  write(0,*) "quantile d/m = ", qnt_d,qnt_m

  call from_param ("r_th_d", r_th_d, -1.0)
  call from_param ("r_th_m", r_th_m_origi, -1.0)

  call from_param (csz_eps, eps);
  call from_param (csz_alpha,alpha);

  call from_param   ("norm_dat", str_norm_dat, 'l2')
  call from_param   ("norm_mod", str_norm_mod, 'hybrid')
  write(0,*) "norm dat/mod residue=", str_norm_dat, str_norm_mod


  call from_param (csz_filt_len, iFilterLen)
  write(0,*) 'filter length=', iFilterLen 

  call from_param  ('zero_lag', zero_lag, 0)  !Default 0, means causal filter
  call from_param  (csz_calc_b_first, l_invert_b_first,.false.)

  axis1.l = "time(sec)"
  axis2.l = "x(km)"
  !!Output model A
  call houtaxis(axis1,1)
  call houtaxis(axis2,2)

  call houtaxis(axis1,1,csz_resda)
  call houtaxis(axis2,2,csz_resda)
  
  !!output model B
  call houtaxis(axis1,1,csz_model_b)
  call houtaxis(axis2,2,csz_model_b)

  call houtaxis(axis1,1,csz_resdb)
  call houtaxis(axis2,2,csz_resdb)

  !SET THE DIMENSIONS of OUTPUT DUMP FILE
  iRecord = 1
  nframe = (niter_nl)/iRecord + 1
  write(0,*) "nframe=",nframe
 
  call set_axis(axisT,iFilterLen,axis1.d,0.0,axis1.l)
  call set_axis(axis_iter,nframe,1.0,1.0,"iter No.")

  call houtaxis(axisT,1, csz_filterA)
  call houtaxis(axisT,1, csz_filterB)
  call houtaxis(axis_iter,2,csz_filterA)
  call houtaxis(axis_iter,2,csz_filterB)

  call houtaxis(axis_iter,3)
  call houtaxis(axis_iter,3,csz_model_b)

  call houtaxis(axis_iter,3,csz_resda)
  call houtaxis(axis_iter,3,csz_resdb)

  maxConvLength = 256 !have enough length
  n12 = n1*n2

allocate (d(n12),b_r_d_conv(n12),d_a_conv_r(n12),&
  				& dd(n12), model_a(n12),model_b(n12),d_conv_a(n12))

  allocate (a(iFilterLen), b(iFilterLen),ra(iFilterLen),rb(iFilterLen))
  allocate (wavelet(maxConvLength),convRes(maxConvLength))

  allocate (resda(n12),resdb(n12),resm(n12))
  allocate (a_and_m(iFilterLen+n12),mask(iFilterLen+n12))

  wavelet=0; convRes=0

  call sep_read(wavelet,csz_wavelet)

  d = 0; ra = 0; rb = 0
  b_r_d_conv = 0; d_a_conv_r = 0

  a = 0; b = 0
  a(1+zero_lag) = 1.0
  b(1+zero_lag) = 1.0

  model_a = 0; model_b = 0

  !deallocate !!!

  !Initialize mask 
  mask = .true.
  mask(1+zero_lag) = .false.
  call mask1_init(mask)

  call sep_read(d)
  !write(0,*) "d= ",d
  
  write(0,*) 'mark3'


do iter_nl=1, niter_nl+1




!!!################################################## Error Dump

     !dump filter a0 and model m0 to file
     bsave = (mod(iter_nl-1,iRecord) .eq. 0)
     if (bsave) then
        write(0,*) "bsave==true, at iter",iter_nl
        call sep_write(a,csz_filterA)
        call sep_write(model_a)

		  call sep_write(resda,csz_resda)
		  call sep_write(resdb,csz_resdb)
     end if

!!!################################################## Error Dump
     if (bsave) then
        call sep_write(b,csz_filterB)
        call sep_write(model_b,csz_model_b)
     end if

  if (iter_nl .eq. niter_nl+1) exit


  if (.not.l_invert_b_first) then
     !INVERSION STEP I: invert a 
	  call invert_a
     !Step II: invert for b
  	  call invert_b
  else
	  call invert_b
	  call invert_a
  endif


  end do ! non-linear iter loop

  !convolve wavelet*a*rev(b)
  call t_conv_filter_init(wavelet,maxConvLength,1)
  stat = t_conv_filter_lop(F,F,a,convRes);
  call t_conv_filter_init(convRes,maxConvLength,1)
  stat = t_conv_filter_lop(F,F,rb,wavelet);

  call hinaxis(axis_wavelet,1,csz_wavelet);
  axis_wavelet.n = size(wavelet)
  call houtaxis(axis_wavelet,1,csz_convRes)
  call sep_write(wavelet,csz_convRes)

  deallocate(mask,a,b,ra,rb)
  deallocate(d,dd,model_a,model_b,d_conv_a,d_a_conv_r,b_r_d_conv)
  deallocate(resda,resdb,resm)

  call sep_close()
end program
