

program Sparse_decon_mixed_linear
  use sep
  use util_axisIO

  !use solver_reg_nrm_bd_mod
  use solver_smp_nrm_mod
  use plane_search_mod
  use mask1

  use t_conv_filter_combine  
  use t_conv_filter
  use t_conv_data   
  use misc

  implicit none

  integer :: n1,n2
  type(myaxis)  axis1, axis2, axis_iter,axis_wavelet

  ! <in.H Sparse_decon filt=filter.H > out.H



  integer ::filter_len

  integer                          :: niter_nl,niter_lin, iter_nl

  real                             :: qnt_d,qnt_m
  real                             :: r_th_d, r_th_m, r_th_m_origi
  logical                          :: l_use_rthd, l_use_rthm


  integer :: zero_lag
  integer :: max_overshot_cnt

  real, dimension(:),allocatable :: tmp_ar
  integer :: psiter      !maximum iterations allowed in plan search
  integer :: qt_period   !Allow quantile change after certain iterations

  character(12)  ::str_norm_mod, str_norm_dat
  integer        ::stat

  real, dimension(:), allocatable :: error
  integer :: niter0

  logical bsave,T,F
  integer i,j,k, nframe,n12

  logical :: bUseMask
  type(myaxis) :: axisT,axisTb,axis_dummy

  integer:: iRecord, iFilterLen,maxConvLength,iShift,iFilterbLen;
  
  !real, allocatable, dimension(:) :: filter_specreg
  real, dimension(:),allocatable:: d,b_r_d_conv,d_a_conv_r,d_conv_a,dd,model_a,model_b,a_r_b_d_conv,d_a_conv
  real, dimension(:),allocatable::d_conv_delta_a,d_delta_a_delta_rb
  real, dimension(:), allocatable :: a,b,ra,rb,wavelet,convRes
  real, dimension(:),allocatable:: delta_a, delta_b,delta_rb
  real, dimension(:),allocatable:: delta_rb_a
  logical, pointer, dimension(:) :: maska, maskb
  integer gap
  real :: maxV

real, dimension(:),allocatable::test,result_test
  
  !All the tags in params
  character(len=256) :: csz_filterA,csz_filterB,csz_qntd,csz_qntm,csz_niter_nl, &
  & csz_niter_lin,csz_psiter,csz_qt_period,csz_filt_len,csz_filtb_len,&
  & csz_model_b,csz_wavelet, csz_convRes, csz_gap

  csz_filterA = "filter_a"
  csz_filterB = "filter_b"
  csz_qntd = "qnt_d"
  csz_qntm = "qnt_m"
  csz_niter_nl = "niter_nl"
  csz_niter_lin = "niter_lin"
  csz_psiter = "psiter"
  csz_qt_period = "qt_period"
  csz_filt_len = "filt_length"
  csz_filtb_len= "filtb_length"
  csz_model_b = "model_b"
  csz_wavelet = "wavelet"
  csz_convRes = "conv_res"
  csz_gap = "gap"
  T = .true. ; F = .false.
  !Params
  call sep_init()

  call from_param("UseMask",bUseMask,.false.)

  call hinaxis(axis1,1)
  call hinaxis(axis2,2)
  n1 = axis1%n; n2 = axis2%n

  call from_param (csz_niter_nl, niter_nl, 1)
  call from_param (csz_niter_lin, niter_lin, 1)   !should be a small number
  write(0,*) "niter_nl/lin=",niter_nl, niter_lin

  call from_param (csz_psiter,psiter,2); write(0,*) "psiter=",psiter

  call from_param (csz_qt_period,qt_period,1000); 
  write(0,*) csz_qt_period,"=",qt_period
  
  call from_param ("max_overshot_shrink_cnt", max_overshot_cnt, 0)
  write(0,*) "max_overshot_cnt=", max_overshot_cnt

  call from_param   (csz_qntd, qnt_d, .9) 
  call from_param   (csz_qntm, qnt_m, .9) 
  write(0,*) "quantile d/m = ", qnt_d,qnt_m

  call from_param ("r_th_d", r_th_d, -1.0)

  call from_param   ("norm_dat", str_norm_dat, 'l2')
  write(0,*) "norm dat residue=", str_norm_dat

  call from_param (csz_filt_len, iFilterLen)
  call from_param (csz_filtb_len, iFilterbLen, iFilterLen) !Default filter a,b equal length
  write(0,*) 'filter length=', iFilterLen, ' / ', iFilterbLen 
  call from_param (csz_gap, gap,0)
  write(0,*) 'gap =', gap
  call from_param  ('zero_lag', zero_lag, 0)  !Default 0, means causal filter

  axis1.l = "time(sec)"
  axis2.l = "x(km)"
  !!Output model A
  call houtaxis(axis1,1)
  call houtaxis(axis2,2)
  !!output model B
  csz_model_b = "model_b"
  call houtaxis(axis1,1,csz_model_b)
  call houtaxis(axis2,2,csz_model_b)

  !SET THE DIMENSIONS of OUTPUT DUMP FILE
  iRecord = 1
  nframe = (niter_nl-1)/iRecord + 1
  write(0,*) "nframe=",nframe
 
  call set_axis(axisT,iFilterLen,axis1.d,0.0,axis1.l)
  call set_axis(axisTb,iFilterbLen,axis1.d,0.0,axis1.l)
  call set_axis(axis_iter,nframe,1.0,1.0,"iter No.")

  call houtaxis(axisT,1, csz_filterA)
  call houtaxis(axisTb,1, csz_filterB)
  call set_axis(axis_dummy,1,1.0,1.0,"")
  call houtaxis(axis_dummy,2,csz_filterA)
  call houtaxis(axis_dummy,2,csz_filterB)
  call houtaxis(axis_iter,3,csz_filterA)
  call houtaxis(axis_iter,3,csz_filterB)

  call houtaxis(axis_iter,3)
  call houtaxis(axis_iter,3,csz_model_b)


  maxConvLength = 512 !have enough length
  n12 = n1*n2
	allocate (d(n12),b_r_d_conv(n12),a_r_b_d_conv(n12),&
  				& dd(n12), model_a(n12),d_conv_a(n12),d_a_conv(n12))

  allocate (a(iFilterLen), b(iFilterbLen),ra(iFilterLen),rb(iFilterbLen))
  allocate (delta_a(iFilterLen), delta_b(iFilterbLen),delta_rb(iFilterbLen))
  allocate(d_conv_delta_a(n12),d_delta_a_delta_rb(n12))
  allocate (maska(iFilterLen+iFilterbLen))
  allocate (delta_rb_a(iFilterLen+iFilterbLen))
  allocate (wavelet(maxConvLength),convRes(maxConvLength))

  wavelet=0; convRes=0

  call sep_read(wavelet,csz_wavelet)
  !write(0,*) 'wavelet: ', wavelet

  d = 0; ra = 0; rb = 0
  b_r_d_conv = 0; d_a_conv_r = 0
  a_r_b_d_conv=0
  a = 0; b = 0
  model_a = 0; model_b = 0
  delta_rb_a=0
  delta_a=0; delta_b=0; delta_rb=0

  !deallocate !!!

  ! Use initial wavelet
  a(1+zero_lag) = 1.0
  
  b(1+zero_lag) = 1.0

  maska = .true.
  maska(1+zero_lag+iFilterblen) = .false.
  maska(1+zero_lag+iFilterblen-1) = .false.





  call sep_read(d)

  
  call reverseArray(b,rb,iFilterbLen,1)





do iter_nl=1, niter_nl+1


  !Linearized inversion

  !d*a
  call t_conv_data_init(a,n1,n2)
  stat = t_conv_data_lop(.false.,.false.,d,d_conv_a)

  !d*rb  
  !call reverseArray(b,rb,iFilterbLen,1)
  !write(0,*) "rb=", rb
  call t_conv_data_init(rb,n1,n2)
  stat = t_conv_data_lop(.false.,.false.,d,b_r_d_conv)

  !d*a*rb
  call t_conv_filter_init(d_conv_a,n1,n2)
  stat = t_conv_filter_lop(.false.,.false.,rb,a_r_b_d_conv)

!   !d*delta_a*delta_rb
  call t_conv_data_init(delta_a,n1,n2)
  stat = t_conv_data_lop(.false.,.false.,d,d_conv_delta_a)
  call t_conv_filter_init(d_conv_delta_a,n1,n2)
  stat = t_conv_filter_lop(.false.,.false.,delta_rb,d_delta_a_delta_rb)
 


  delta_a=0; delta_b=0; delta_rb=0
  !call reverseArray(delta_b,delta_rb,iFilterbLen,1)
  delta_rb_a(1:iFilterbLen)=delta_rb(1:iFilterblen)
  delta_rb_a(iFilterbLen+1:)=delta_a(1:iFilterlen)
!!!################################################## Error Dump

     !dump filter a0 and model m0 to file
     bsave = (mod(iter_nl-2,iRecord) .eq. 0 .and. iter_nl.gt.1)
     if (bsave) then
        write(0,*) "bsave==true, at iter",iter_nl
        call sep_write(a,csz_filterA)
!   call t_conv_data_init(a,n1,n2)
!   stat = t_conv_data_lop(.false.,.false.,d,d_a_conv)
!   call t_conv_filter_init(d_a_conv,n1,n2)
!   stat = t_conv_filter_lop(.false.,.false.,rb,model_a)
  call shiftArray(model_a,n1,n2,iFilterblen-1)
        call sep_write(model_a)
     end if

!!!################################################## Error Dump
     if (bsave) then
        call sep_write(rb,csz_filterB)
     end if

  if (iter_nl .eq. niter_nl+1) exit

  !Init opertor
  !write(0,*) "b_r_d_conv",b_r_d_conv

  call t_conv_filter_combine_init(d_conv_a,b_r_d_conv,n1,n2,iFilterbLen)
  dd = 0

  call mask1_init(maska)

  if (abs(r_th_d + 1.0)<1e-5) then !use quantile
	  call solver_smp_nrm(m=delta_rb_a, m0=delta_rb_a, d=dd-a_r_b_d_conv-d_delta_a_delta_rb, Fop=t_conv_filter_combine_lop, Jop=mask1_lop, &
          & stepper=cgstep_ps,niter=niter_lin,&
          & norm_in=str_norm_dat,&
          & qnt=qnt_d, &
          & psiter=psiter, overshot_shrink_max_cnt_in=max_overshot_cnt, qt_period_in=qt_period,&
          & resd=model_a,verb=.True.)
  else
	  call solver_smp_nrm(m=delta_rb_a, m0=delta_rb_a, d=dd-a_r_b_d_conv-d_delta_a_delta_rb, Fop=t_conv_filter_combine_lop, Jop=mask1_lop, &
          & stepper=cgstep_ps,niter=niter_lin,&
          & norm_in=str_norm_dat,&
          & R_th_in=r_th_d, &
          & psiter=psiter, overshot_shrink_max_cnt_in=max_overshot_cnt, qt_period_in=qt_period,&
          & resd=model_a,verb=.True.)
  endif
  
  delta_rb(1:iFilterblen)=delta_rb_a(1:iFilterbLen)
  delta_a(1:iFilterlen)=delta_rb_a(iFilterbLen+1:)

  a=a+delta_a

  rb=rb+delta_rb

  
  call solver_smp_nrm_close()




end do 


  deallocate(maska,a,b,ra,rb)
  deallocate(d,dd,model_a,d_conv_a,b_r_d_conv,d_conv_delta_a,d_delta_a_delta_rb,d_a_conv)
  deallocate(a_r_b_d_conv,delta_a,delta_b,delta_rb,delta_rb_a)


  call sep_close()
end program
