!Convert an .H file to Helix Filter file, or vice versa simple 1D case
program To_helix

  use sep
  use util_axisIO

  implicit none

  integer i,n1

  real,allocatable,dimension(:) :: flt,d
  integer,allocatable,dimension(:) ::lag
  integer  :: tohelix  ! =1 then from .H to helix, =0 then backward   
  type(myaxis) :: axis1

  call sep_init()

  call hinaxis(axis1,1)
  call print_axis(axis1)

  call from_param('tohelix',tohelix)

  if (tohelix==1) then
     n1 = axis1%n
     axis1%n = n1 - 1
     call houtaxis(axis1,1)

     allocate(flt(n1-1),lag(n1-1),d(n1));

     do i=1,n1-1
        lag(i) = i
     end do

     call sep_read(d)
     d = d/d(1)
     flt = d(2:n1);

     call to_history('lag', lag)
     call to_history("n2",1)
     call sep_write(flt)

  else if (tohelix==0) then  !
     n1 = axis1%n
     
     allocate(lag(n1),flt(n1));
     call sep_read(flt)
     
     call from_history('lag',lag)
     if (n1 .ne. maxval(lag)) then
        write(0,*) 'n1 is not equal to maxval of lag array, there are zeros among the filter coef'
     end if
     
     n1 = n1+1
     axis1%n = n1
     call houtaxis(axis1,1)
     call to_history('n2',1)
     allocate(d(n1))

     d(2:n1) = flt
     d(1) = 1.0
     call sep_write(d)

  else
     write(0,*) "tohelix parameter is wrong !"
  end if

  deallocate(flt,lag,d)
  call sep_close()
end program To_helix
