module Kirchhoff
! Kirchhoff migration and diffraction. (greased lightning)
!
implicit none
contains

subroutine kirchfast(adj, add,velhalf,amax,t0,dt,dx, nt,nx, modl, data)
integer 		:: ix,iz,it,ih, adj, add, nt,nx, xstart, xend
real 		:: amp,t,z,h, velhalf(nt),amax,t0,dt,dx,modl(nt,nx), data(nt,nx)
REAL :: pi,r2d,ataper,taper
pi = 2*ACOS(0.0)
r2d = 180/pi
ataper = amax*2/3

if (adj==1) then
   modl=0
else
   data=0
end if 

do ih= -nx, nx
  h = dx * ih ! h = offset
  do iz= 2, nt
    z = t0 + dt * (iz-1) ! z = travel-time depth
    t = sqrt( z**2 + (h/velhalf(iz))**2 )
    it = 1.5 + (t - t0) / dt
    if ( it > nt ) then
      exit
    end if
    if ( acos(z/t)*r2d > amax ) then
      cycle
    end if
    if ( acos(z/t)*r2d > ataper ) then
      taper = cos( ( acos( z / t ) * r2d - ataper ) / ( amax - ataper ) * pi / 2 )
      amp = ( z / t ) * sqrt( nt*dt / t ) * taper
    else
      amp = ( z / t ) * sqrt( nt*dt / t )
    end if
    xstart = 1-ih
    xstart = max0( 1, xstart)
    xend = nx-ih
    xend = min0( nx, xend)
    if ( adj .eq. 0 ) then
      do ix= xstart, xend
        data(it,ix+ih)=data(it,ix+ih)+modl(iz,ix )*amp
      end do
    else
      do ix= xstart, xend
        modl(iz,ix )=modl(iz,ix )+data(it,ix+ih)*amp
      end do
    end if
  end do
end do

end subroutine
end module
